Девайсы. "Стандартный" разъем для программирования микроконтроллеров Atmega

Если вы всерьез решили заняться радиоэлектроникой, а особенно микропроцессорной электроникой, то рано или поздно вы придете к пониманию того, что без стандартных разъемов для внутрисхемного программирования своих девайсов не обойтись.

Существует несколько рекомендуемых видов разъемов для подключения ваших устройств на базе микропроцессоров Atmega к программатору. Вот некоторые из них (вид со стороны монтажных элементов, как будто смотрим на плату сверху):


Стандартные разъемы для программирования устройств на базе микропроцессоров Atmega


В качестве разъемов для установки на печатную плату своего устройства удобно использовать штырьковые разъемы от "мертвых" материнских плат или подобных устройств.


Штырьковые разъемы на материнской плате


Для подключения к программатору (например к USBASP) для каждого вида разъема лучше всего изготовить отдельный дата-кабель. Например дата кабель для подключения к разъему V4 может выглядеть так:


Дата-кабель V4 для внутрисхемного программирования устройств на базе микроконтроллеров Atmega


Что касается распиновки 9-и пинового разъема дата-кабеля, то она приведена ниже. Обратите внимание на то, что этого этот разъем подходит только для программатора USBASP, собранного на печатной плате, приведенной на данном ресурсе.


Распиновка 9-и пинового разъема дата-кабеля

Скачать макросы разъемов для программы Sprint Layout для внутрисхемного программирования устройств на микроконтроллерах Atmega.

Девайсы. Программатор USBASP для микроконтроллеров Atmega

Приведенная ниже конструкция программатора USBasp (официальная страница) на мой взгляд является оптимальной при прошивке микроконтроллеров семейства Atmega. Она проста, надежна, легко повторяема и не содержит дефицитных элементов.

Схема программатора представлена ниже:

Схема программатора USBаsp


Токоограничительные сопротивления R4, R5, R9-R12 можно не устанавливать (на печатной плате не предусмотрены, у меня установлены в разрыв соответствующих дорожек с обратной стороны платы) - служат для защиты микроконтроллера программатора от КЗ при неправильном монтаже целевого устройства.

Печатная плата программатора USBаsp


Перемычками J1-J3 устанавливается режим работы программатора:

J1 – служит для первоначального программирования микроконтроллера на печатной плате;

J2 – для программирования микроконтроллеров на пониженной частоте;

J3 – для питания микроконтроллеров от USB порта при программировании.

В готовом устройстве эти перемычки, как правило, установлены следующим образом:

J1 – разомкнуто;

J2 – в зависимости от микроконтроллера (в большинстве случаев - разомкнуто);

J3 – замкнуто.

Единственное неудобство при изготовлении этого устройства – необходимость запрограммировать микроконтроллер ATMega8, на базе которого построен программатор. Это можно сделать самому – используя схему из пяти проводов, попросить помощи у товарища, у которого есть готовый программатор или заказать у меня запрограммированный и проверенный на работоспособность микроконтроллер.

Схема программатора "5 проводов"


В конечном итоге должно получиться нечто такое:

Готовый программатор USBasp


Скачать схему программатора USBasp, печатную плату в формате Sprint Layout v. 5.0, прошивку программатора и настройки фьюзов.

Новые версии прошивок и драйверов см. на официальном сайте.

Android Studio. Натройка темы

Для того, что бы изменить стандартную тему (скин) в Android Studio выбираем "File -> Settings -> Appearance" и изменяем параметр "Theme". Мне, например, нравиться тема "Dracula".

Изменение темы в Android Studio

Android Studio. Настройка папок SDK и JDK из IDE

Когда требуется изменить расположение папок Android SDK Tools (SDK) и Java SE Development Kit (JDK) из Android Studio выбираем "File -> Other Settigs -> Default Project Strucrure" и задаем соответствующие параметры:

Настройка папок SDK и JDK в Android Studio

Android Studio. Установка и настройка

Android Studio - среда разработки программного обеспечения для Android девайсов. Как заявляет Google это и тесть та официальная IDE для Android-устройств, а как для меня - это замена старой доброй Eclipse на что-то более новое и современное.

Android Studio


1. Идем на http://developer.android.com/sdk/index.html и скачиваем дистрибутив IDE. Установку можно выполнить полным дистрибутивом из файла "android-studio-bundle-XXX.XXXXXXX.exe (Recommended)" и дальше статью не читать, но поскольку я переезжаю с Eclipse, то в качестве дистрибутива я выбрал, скачал и установил "android-studio-ide-XXX.XXXXXXX.exe (No SDK tools included)".

2. Теперь необходимо указать папки расположения Android SDK Tools (SDK) и Java SE Development Kit (JDK). Для чего при первом запуске выбираем "Configure -> Project Defaults -> Project Structure":

Android Studio. Настройка папок SDK и JDK

Eclipse. Создание библиотек классов для Android

Для того, что бы каждый раз не переписывать ранее разработанные классы в новые проекты разумнее всего создать библиотеку классов. В Eclipse это делается так:

1. Создаем новый проект.



2. Во время создания проекта, если в библиотеке не предполагается наличия Activity можно убрать галочку "Create Activity".



3. Переходим в свойства проекта. Выбираем папку проекта, нажимаем правую кнопку мыши, нажимаем "Properties". Или добираемся к свойствам через меню "File -> Properties".



4. Переходим в свойство "Android". Устанавливаем признак "Is Library"



Библиотека готова. Теперь ее необходимо подключить к проекту. Делается это так:

1. Переходим в свойства проекта к которому желаем подключить библиотеку (Выбираем папку проекта, нажимаем правую кнопку мыши, нажимаем "Properties").

2. Переходим в свойство "Android". В секции "Library" нажимаем кнопку "Add". В появившемся окне выбираем библиотеку, которую хотим подключить.


Eclipse. Ошибка "Android requires compiler compliance level 5.0 or 6.0. Found '1.7' instead"

Когда-то на форуме задавал такой вопрос:

"Воспользовавшись советами коллег решил и я попытать счастья в освоении игровых движков для Android, пошупав e3roid-1.2.11. При установке ("File -> Import -> Existing Project in to Workspace) оного в клипсу компилятор выдает "Android requires compiler compliance level 5.0 or 6.0. Found '1.7' instead". И рекомендует «Please use Android Tools > Fix Project Properties». Собственно говоря, вопрос - где этот Tools живет и как его запустить (SDK Манагер говорит, что Tools установлен)?"

А потом сам же нашел на него ответ на каком-то забугорном форуме:

1. На папке с проектом, нажимаем правую кнопку мыши и выбираем "Android Tools -> Fix Project Properties". Если не помогло - смотрим п. 2.



2. На папке с проектом, нажимаем правую кнопку мыши и выбираем "Properties -> Java Compiler", устанавливаем галку "Enable project specific settings" и выбираем "Compiler compliance settings" 1.5 или 1.6.